/*
 * //gW - Guenter Wahl ...    mail.js  vers.2006-10-12
 *
 * code imported to have "search a message by "MesageID" from within ReminderFox Dialog window
 * ............................................................... 
 * based on 
 *    MessageID-Finder for Mozilla 'messageidfinder-2.0.0.xpi' by markushossner@gmx.de and 
 *    'reminderfox-0.9.6.xpi' by Daniel Lee, Tom Mutdosch
 */

/*
 * part 1   -------------------------
 *
 * Add email reminder for current selected message
 */
function reminderFox_thunderBirdAddEmailReminder() {
        var msgHdr = gDBView.hdrForFirstSelectedMessage;
 
    // subject
        var remFoxSummary = msgHdr.mime2DecodedSubject;
    // from
        var remFoxFrom =  msgHdr.mime2DecodedAuthor;        
    // recipients
        var remFoxTo = msgHdr.mime2DecodedRecipients;        
        
 		//  add text from hightlighted mail-text
 		var remFoxDetails = null;
        var focusedWindow = document.commandDispatcher.focusedWindow;
        var selectedText = focusedWindow.getSelection();

        if (selectedText != null && selectedText != "") {
        	 remFoxDetails = "\n\n" +	reminderFox_getBundle().getString("rf.add.mail.message.details") + 
        	 	":\n" + 	selectedText.toString();        
        }
        

    // messageID
        var messageId =  msgHdr.messageId;
    // strip out quotes as the extractHeader method returns some message-id's with extraneous quotes
    // like: "000c01c6941b$6ddb3c30$7be040"@foo.com
        messageId = messageId.replace(new RegExp(/\"/g),"");
        var remFoxMessageID = "<" + messageId + ">";
       
    // date   
        var dateStr =  msgHdr.date;
        var time = new Date();
           // PRTime is in microseconds, Javascript time is in milliseconds
           // so divide by 1000 when converting
        time.setTime(dateStr / 1000);
   
        var timeString = reminderFox_mail_getTimeString( time );
        var dateVariableString;
        try {
            dateVariableString = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LIST_DATE_LABEL);
        } catch(e) {
        }           
        var remFoxDate =reminderFox_getDateVariable( null, time, dateVariableString ) + "  " + timeString;
        
	var newDate = new Date();
	newDate.setDate( newDate.getDate() + 1 );  // default to using tomorrow's date for reminder

	var reminderId =reminderFox_generateUniqueReminderId( newDate );
	var mailIdentifierString = reminderFox_getBundle().getString("rf.add.mail.message.mail.identifier");
	var	newReminderToBeAdded = new ReminderFoxEvent( reminderId, newDate, mailIdentifierString + " " + remFoxSummary );
	newReminderToBeAdded.messageID = remFoxMessageID;
	// newReminderToBeAdded.recurrence = REMINDER_RECURRENCE_ONETIME;

	// add default message header info to the Notes section
	newReminderToBeAdded.notes = 
	    reminderFox_getBundle().getString("rf.add.mail.message.sender")	     + ": " + remFoxFrom   +  "\n" + 
	    reminderFox_getBundle().getString("rf.add.mail.message.recipients")	 + ": " + remFoxTo     +  "\n" + 
		reminderFox_getBundle().getString("rf.add.mail.message.date")    	 + ": " + remFoxDate   +  "\n" + 
		reminderFox_getBundle().getString("rf.add.mail.message.subject")     + ": " + remFoxSummary; 
	
	if ( remFoxDetails != null ) { 
		newReminderToBeAdded.notes = newReminderToBeAdded.notes + remFoxDetails;
	}
		
	var newOptions = { reminder: newReminderToBeAdded, editing:  false,  addReminder: false };
	window.openDialog("chrome://reminderfox/content/reminderOptionsDialog.xul",
			"reminderOptionsDialog", "chrome,resizable,modal", newOptions );

	if ( newOptions.addReminder ) {
		var currentDate = new Date();
		if ( newReminderToBeAdded.alarm != null ) {
			newReminderToBeAdded.alarmLastAcknowledge = currentDate.getTime();
		}
		newReminderToBeAdded.lastModified = reminderFox_getDateAsString(currentDate );
		
		// add reminder in sorted order...

		// add to edit reminder dialog if it is open
	   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");	 
	   if (topWindow) {
	   		var newDate = oeDatePicker.gSelectedDate;
			if ( newDate == null ) {
				newDate = new Date();
			}	
			var originalYear = newDate.getFullYear();
	   		// if adding a new reminder in a different year, first set the list/calendar to the new year
			// before adding the reminder
			if ( originalYear != newReminderToBeAdded.date.getFullYear() ) {
			   	topWindow.oeDatePicker.gSelectedDate = newReminderToBeAdded.date;
				topWindow.repopulateListForYear( originalYear, newReminderToBeAdded.date.getFullYear() );
			}
	   	
	   		topWindow.focus();
	   		var reminders = topWindow.reminderFox_getReminderEvents();	
			var sortedIndex = topWindow.reminderFox_getSortedIndexOfNewReminder( reminders, newReminderToBeAdded, false );
			topWindow.reminderFox_insertIntoArray( reminders, newReminderToBeAdded, sortedIndex );
	   	
			topWindow.createListItem(newReminderToBeAdded);
			topWindow.oeDatePicker.onpopupshowing(newReminderToBeAdded.date);			
			topWindow.modifiedReminders();	
		}		
		else {
			// add reminder headlessly
			var reminders = reminderFox_getReminderEvents();	
			var sortedIndex = reminderFox_getSortedIndexOfNewReminder( reminders, newReminderToBeAdded, false );
			reminderFox_insertIntoArray( reminders, newReminderToBeAdded, sortedIndex );
		}
		
		// this 'labels' the mail-item and colorize it "violett"    
		goDoCommand("cmd_label5") 
	
		reminderFox_writeOutRemindersAndTodos(false);
		reminderFox_syncWrittenChangesToRemote(	);
		try {
			// update all of the browsers
			windowEnumerator =  reminderFox_getWindowEnumerator();
			while (windowEnumerator.hasMoreElements()) {
				var currentWindow = windowEnumerator.getNext();		
				currentWindow.reminderFoxEvents = reminderFoxEvents;
				currentWindow.reminderFoxTodosArray  = reminderFoxTodosArray;

				currentWindow.reminderFox_updateRemindersInWindow();			
				currentWindow.reminderFox_clearRemindersAndTodos();
			}
		}
		catch(e) {
		}				
	}			
}

/* 
 * part 2  ---------------------
 *
 *    retrieve and display this reminder's associated email in Thunderbird
 */

function reminderFox_doShowMail() {
	var currentReminder = getReminderForSelectedItem( );
	if ( currentReminder.messageID != null ) {
		reminderFox_openByMessageID(currentReminder);
	}
}

function reminderFox_doShowMailTodo() {
	var currentTodo = getTodoForSelectedItem( );
	if ( currentTodo.messageID != null ) {	
		reminderFox_openByMessageID(currentTodo);	
	}
}

function reminderFox_doShowMailShortcut() { 
	var remindersTab = document.getElementById("remindersTab");
	if ( remindersTab.selected ) {
		reminderFox_doShowMail();
	}
	else {
		reminderFox_doShowMailTodo();
	}
}

function reminderFox_openByMessageID(currentReminder){
	// this function only works in ThunderBird -
	// if using Firefox, this starts Thunderbird ... and {for the moment}
	// requires to manually reselect the "view Mail" in TB/reminderFox environment
    if( !reminderFox_isThunderBird() ) {   	
	// gW alert( reminderFox_getBundle().getString("rf.add.mail.thunderbird.message") );
			{   
			var  shell = Components.classes["@mozilla.org/browser/shell-service;1"]
				.getService(Components.interfaces.nsIShellService);
	
			if (shell)
				shell.openApplication(Components.interfaces.nsIShellService.APPLICATION_MAIL);
			}
    	return;
    }   
	
	var messageId = currentReminder.messageID;

 	var midleft = (messageId.toLowerCase()).search("<"); 
 	var finalMessageId;
 	if (midleft == -1)
      	finalMessageId = "";
	else {
 	   var midRight = (messageId.substring(midleft)).search(">");
       finalMessageId =  messageId.substring(midleft + 1, midRight );
      }

	if (finalMessageId !="" )  reminderFox_MessageIdFinder(finalMessageId);
}

function reminderFox_clearLabelByMessageID(messageId){
	// this function only works in ThunderBird -
	// if using Firefox, this starts Thunderbird ... and {for the moment}
	// requires to manually reselect the "view Mail" in TB/reminderFox environment
    if( !reminderFox_isThunderBird() ) {   	
	// gW alert( reminderFox_getBundle().getString("rf.add.mail.thunderbird.message") );
			{   
			var  shell = Components.classes["@mozilla.org/browser/shell-service;1"]
				.getService(Components.interfaces.nsIShellService);
	
			if (shell)
				shell.openApplication(Components.interfaces.nsIShellService.APPLICATION_MAIL);
			}
    	return;
    }   

 	var midleft = (messageId.toLowerCase()).search("<"); 
 	var finalMessageId;
 	if (midleft == -1)
      	finalMessageId = "";
	else {
 	   var midRight = (messageId.substring(midleft)).search(">");
       finalMessageId =  messageId.substring(midleft + 1, midRight );
      }

	if (finalMessageId !="" )  reminderFox_OpenMessageByMessageID( finalMessageId, false, 0);
}

function reminderFox_mail_getTimeString( date ) {
	var timeString = null;
	try {
		var hours = date.getHours();
		var AMorPM;
			
		var use24HourTime;
		try {
			use24HourTime = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USE_24_HOUR_TIME);
		} catch(e) {
		}				
		if (  use24HourTime ) {
			AMorPM = "";
			if ( hours < 10 ) {
				hours = "0" + hours;
			}
		}
		else {
			AMorPM  =reminderFox_getBundle().getString("rf.add.time.PM");
			if ( AMorPM != "" ) {
				if ( hours < 12 ) {
					AMorPM = reminderFox_getBundle().getString("rf.add.time.AM");
				}
				if ( hours == 0 ) {
					hours = 12;
				}
				if ( hours >= 13 ) {
					hours = hours -12;
				}	
			}	
		}
		var minutes = date.getMinutes();
		if ( minutes < 10 ) {
			minutes = "0" + minutes;
		}
						
		timeString = hours + reminderFox_getBundle().getString("rf.add.time.delimiter") + minutes;
		if ( AMorPM != "" ) {
			timeString = timeString + " " + AMorPM;		
		}
	}
	catch ( e ) { 
	}
	
	return timeString;
}


/*
 * part 3   -------------------------
 *
 * based on: MessageID-Finder for Mozilla by
 * 
 * Markus Hossner - markushossner@gmx.de
 * 
 */

const reminderFox_pmpB = 0;
const reminderFox_pmpN = 1;
const reminderFox_pmpS = 2;

var reminderFox_prefRead = false;
var reminderFox_accountURIs = new Array();
var reminderFox_msgWindow;


function reminderFox_MessageIdFinder(strmessageid) {
    
    strmessageid = reminderFox_ExtractMessageID(strmessageid);

    var msgHdr = reminderFox_OpenMessageByMessageID(strmessageid,true);

	if (!msgHdr) {
		var strMsgIdNotFound = reminderFox_getBundle().getString("rf.add.mail.messageIdNotFound.message") +	
				"\nMessage-ID: " + strmessageid;  
		alert(strMsgIdNotFound);
		}        
}


function reminderFox_getMsgWindow() {
	if ( reminderFox_msgWindow == null ) {
		reminderFox_msgWindow = Components.classes["@mozilla.org/messenger/msgwindow;1"].
				createInstance(Components.interfaces.nsIMsgWindow);
	}
	return reminderFox_msgWindow;
}


function reminderFox_ExtractMessageID(strmessageid) {
    var midParts = strmessageid.replace(/^<|>$/g, "")
                               .split(":");

    switch (midParts.length) {
        case 1:
            strmessageid = strmessageid;
            break;

        case 2:
            if (midParts[0] == "news" || midParts[0] == "nntp") {
                strmessageid = midParts[1].replace(/^\/\/.*?\// ,"");
            } else if (midParts[0] == "mailto") {
                strmessageid = midParts[1];
            }
            break;

        case 3:
            strmessageid = midParts[2].replace(/^.+?\// ,"");
            break;

        default:
            strmessageid = "";
            break;
    }
    return strmessageid;
}


/*
 * Opens and selects a message by messageid
 *
 *  //gW 2006-10-11  .... added
 *
 *   Finds a message by messageid .... and by option
 *   'openmsginnewwin'
 *     = true    opens msg 
 *     = false   only selects Folder and Pane ... to be able to 'label' the message
 *
 *   Message is labeled with optional parameter
 *   'newLabel'   
 *      =0 no   =1 ... =5  see Label Options with Pull-Down Menue
 */

function reminderFox_OpenMessageByMessageID(messageId,openmsginnewwin,newLabel) {
	reminderFox_AddNewsServers();   
 
    window.setCursor("wait");

    var msgHdr = reminderFox_SearchMessageLocally(messageId);
    if (msgHdr) {
        var folderUri = msgHdr.folder.URI;
        
        if (openmsginnewwin) {
            var folder = reminderFox_GetMsgFolderFromUri(folderUri);
            var messageUri = folder.getUriForMsg(msgHdr);
                     
            window.openDialog("chrome://messenger/content/messageWindow.xul", "_blank",
                              "all,chrome,dialog=no,status,toolbar", messageUri, folderUri, null);
        }
       //  else {
       	// select message in the mail index
            var tree = {};
            var msgDB = {};
            var length = {};
            var wintype = {};
            var msgDBView = {};
            var indicesArray = {};
            
            reminderFox_msgWindow = reminderFox_getMsgWindow();
            if (document.firstChild.id == "messengerWindow") {
                wintype = window.document.firstChild.getAttribute("windowtype");
                reminderFox_msgWindow.SetDOMWindow(window);
                
                folder = reminderFox_GetMsgFolderFromUri(folderUri);
                msgDB = folder.getMsgDatabase(reminderFox_msgWindow);
                msgDB.MarkHdrRead(msgHdr, false, null);
                reminderFox_msgWindow.SelectFolder(folderUri);

                msgDBView = window.gDBView;
                if (wintype != "mail:messageWindow") tree = window.GetThreadTree();
            } else {
                wintype = window.opener.document.firstChild.getAttribute("windowtype");
                reminderFox_msgWindow.SetDOMWindow(window.opener);

                folder = reminderFox_GetMsgFolderFromUri(folderUri);
                msgDB = folder.getMsgDatabase(reminderFox_msgWindow);
                msgDB.MarkHdrRead(msgHdr, false, null);
                reminderFox_msgWindow.SelectFolder(folderUri);

                msgDBView = window.opener.gDBView;
                if (wintype != "mail:messageWindow") tree = window.opener.GetThreadTree();
            }
            
            
            if (wintype != "mail:messageWindow") tree.view.selection.clearSelection();
            msgDBView.selectMsgByKey(msgHdr.messageKey);
            msgDBView.loadMessageByMsgKey(msgHdr.messageKey);
            msgDB.MarkHdrRead(msgHdr, true, null);
            msgDBView.getIndicesForSelection(indicesArray,length);
            if (wintype != "mail:messageWindow") tree.treeBoxObject
                                                     .ensureRowIsVisible(indicesArray.value[0]);
       // }
    }
	//gW  2006-10-11  newLabel 
	if (newLabel != null ) { 	
			goDoCommand("cmd_label0") 
	}	
    window.setCursor("auto");
 
    return msgHdr;
}


/*
 * Searchs for messageid in local folders
 */
function reminderFox_SearchMessageLocally(messageId) {
    var msgHdr = null;
    var folder = null;
    for(var x = 0; x < reminderFox_accountURIs.length && !msgHdr; x++) {
        folder = reminderFox_GetMsgFolderFromUri(reminderFox_accountURIs[x]).rootFolder;
        msgHdr = reminderFox_SearchInSubFolder(folder, messageId);
    }
    return msgHdr;
}

/*
 * Searchs in subfolder
 */
function reminderFox_SearchInSubFolder(folder, messageId) {

    if (folder.hasSubFolders) {
        var subfolders = folder.GetSubFolders();
        var subfolder = null;
        var msgHdr = null;
        var msgDB = null;
        var currentFolderURI = "";

        var done = false;
        
        while(!done) {
            currentFolderURI = subfolders.currentItem()
                                         .QueryInterface(Components.interfaces.nsIRDFResource).Value;
            subfolder = reminderFox_GetMsgFolderFromUri(currentFolderURI);

            if (currentFolderURI.substring(1,7) != "news://") {
                msgHdr = reminderFox_SearchInSubFolder(subfolder, messageId);
            }
            if (!msgHdr) {
            
                try {

                	reminderFox_msgWindow = reminderFox_getMsgWindow();
                    msgDB = subfolder.getMsgDatabase(reminderFox_msgWindow);
                } catch (ex) {

                 // subfolder.updateFolder(reminderFox_msgWindow); // TM: this call was causing a hang in some instances
				// try {
				// // msgDB = subfolder.getMsgDatabase(reminderFox_msgWindow);
				// } catch (ex) {
				// }
                }

                if ( msgDB != null ) {
               	 msgHdr = msgDB.getMsgHdrForMessageID(messageId);
                }
            }
            
            if (msgHdr) return msgHdr;
            
            
            try {
                subfolders.next();
            } catch(e) {
                done = true;
            }
        }
    }

    return null;
}


/*
 * Searchs all availible newsserver
 */
function reminderFox_AddNewsServers() {
    if (reminderFox_prefRead == false) {
        var accounts = reminderFox_pmpReadPref("mail.accountmanager.accounts",reminderFox_pmpS);
        if (accounts) {
            var accountsArray = accounts.split(",");
            
            for (var x = 0; x < accountsArray.length; x++) {
                reminderFox_AddNewsServerMenuItem(accountsArray[x]);
            }
            reminderFox_accountURIs.sort(reminderFox_sortAccountUris);
        }

        reminderFox_prefRead = true;
    }
}


/*
 * Sortfunction for reminderFox_accountURIs Array Local Folder to the rear
 */
function reminderFox_sortAccountUris(a, b) {

    if (a.search(/Local%20Folders/) != -1) {
        return 1;
    } else if (b.search(/Local%20Folders/) != -1) {
        return -1;
    } else if (a < b) {
        return -1;
    } else if (a > b) {
        return 1;
    } else {
        return 0;
    }
}


/*
 * Adds newsserver to the context menu
 */

function reminderFox_AddNewsServerMenuItem(account) {
    var server    = reminderFox_pmpReadPref("mail.account." + account + ".server",reminderFox_pmpS);
    var servertyp = reminderFox_pmpReadPref("mail.server."  + server +  ".type",reminderFox_pmpS);
    var hostname  = reminderFox_pmpReadPref("mail.server."  + server +  ".hostname",reminderFox_pmpS);
    var username  = reminderFox_pmpReadPref("mail.server."  + server +  ".userName",reminderFox_pmpS);

    var accountURI = "";
    
    if (servertyp == "nntp") {
        var servername = reminderFox_pmpReadPref("mail.server." + server + ".name",reminderFox_pmpS);
        var serverport = reminderFox_pmpReadPref("mail.server." + server + ".port", reminderFox_pmpN);
        // var newsservermenuitem;

        if (servername == null) servername = hostname;
        if (serverport == null) serverport = 119;

// newsservermenuitem = document.createElement("menuitem");
// newsservermenuitem.setAttribute("label", servername);
// newsservermenuitem.setAttribute("value",server);
// newsservermenuitem.setAttribute("oncommand","reminderFox_MessageIdFinder('" +
// hostname + "', '" + String(serverport) + "','');");

        accountURI = "news://" + escape(hostname);
    } else if (servertyp == "imap") {
        accountURI = "imap://" + escape(username) + "@" + escape(hostname);
    } else {
        accountURI = "mailbox://" + escape(username) + "@" + escape(hostname);
    }

    if (hostname != null) reminderFox_accountURIs.push(accountURI);
}



/*
 * Reads the value of pmpName out of the mozilla preferences
 */
function reminderFox_pmpReadPref(pmpName, pmpType) {
    var nsIPrefBranch = Components.interfaces.nsIPrefBranch;
    var pref = Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(nsIPrefBranch);
    var pmpValue = null;
    
    if (pref.prefHasUserValue(pmpName)) {
        switch (pmpType) {
            case reminderFox_pmpB:
                pmpValue = pref.getBoolPref(pmpName);
                break;
            case reminderFox_pmpN:
                pmpValue = pref.getIntPref(pmpName);            
                break;
            case reminderFox_pmpS:
                pmpValue = pref.getCharPref(pmpName);
                break;
            default:
                break;
        }
    }
    
    return pmpValue;
}


/*
 * Get msgfolder from Uri
 */
function reminderFox_GetMsgFolderFromUri(uri) {
    var msgfolder = null;
    
    try {
        var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                            .getService(Components.interfaces.nsIRDFService);
        var resource = RDF.GetResource(uri);
        
        if (resource instanceof Components.interfaces.nsIMsgFolder &&
           (resource.parent || resource.isServer))
           msgfolder = resource;
           
    } catch (ex) {}

    return msgfolder;
}